# emotion detection in short texts datasets with Bert 
[Link to the datasets ](https://gitlab.com/Georgios.Hadjiharalambous/emotion-detection-in-short-texts-datasets)

Nowadays, many big companies that run the internet such as Facebook and Twitter have shown great interest in emotion detection in text. These companies want to remove unwanted or dangerous posts and documents,  related \textit{e.g.} to fake news or promoting violence, abuse or discrimination. The creation of an effective and stable tool for detecting emotions in text is therefore of major importance, especially as the world demands equality and end of race and gender discrimination. 

Despite the apparent potential of emotion detection,
"emotion expression in text is very context sensitive and complex" as said in \cite{Seyeditabari2018}. This difficulty can be attributed to the ambiguity in general text has, the contextual circumstances of the excerpt and the set of feelings that might be present instead of just one. These, along with different language-dependent linguistic phenomena contribute to make emotion detection challenging. Accordingly, several proposed models for dealing with emotion detection have seen little success and failed to produce robust results. 

In this project we aim to address this problem by taking advantage of Bert, a pretrained transformer model. Bert can understand the specific context of a sentence by utilizing a bidirectional comprehensive of the text, along with some other tricks discussed analytically in the next chapter. By leveraging Bert we can create an embedding (which encapsulates the whole document's summary) and build a classification layer on top of it, to detect the emotion of the text. Moreover, since Bert is trained on a huge corpus such as English Wikipedia and BookCorpus, it learns and understands many linguistic phenomena and ambiguous words based on their context.

There is information that Bert might not be able to capture inherently from the data. Since we wanted to achieve even better results we provided to the model further sources of information. For instance, Bert cannot provide a score for each word that characterizes the emotion it correspond to. This scoring is an important factor to our task and can immediately suggest certain emotion for a text. To solve this issue we use lexicons embeddings which describe the emotion a word might have. These embeddings are vectors which have scores for the emotions we want to classify the text to and can thus introduce extra information to our model and help it take more accurate decisions. 

The human mind uses a hierarchical process to take complex decisions such as classifying an emotion in text. Through this process, the overall task is broken down to simpler and smaller tasks which can be solved more accurately, reaching a more robust and certain final decision. As our model does not have such a mechanism in place, we take inspiration from the hierarchical process our mind uses to take such decisions as classifying an emotion and transfer this process to our model. We propose the Bert Hierarchical model which enables the aforementioned structure in order to take more accurate and robust decisions. Moreover, we want to understand whether copying this process would help our models achieve better results.

During training and evaluating many models we have observed that some of them are especially good in certain emotion classes and that there is not a model which is perfect. This is the reason we introduce an ensembling model. By ensembling different models we aim to get the best parts of each and by combining them boost our final models' predictions. All the introduced alterations of Bert aim to push our models to better understand text and achieve better classification results.
 
 
Lastly, as an investigatory step and to provide guidance to future researches we wanted to examine which components of the models used are of vital importance. Therefore we break down two small state-of-the-art models -- BiGRU and SASE --  which we also use as baselines throughout the project, and observe which parts of them play a significant role to classifying emotions in text.